﻿namespace IRaCIS.Application.Contracts
{
    public class AttachmentDTO
    {
        public Guid Id { get; set; }
        public Guid DoctorId { get; set; }
        public bool IsOfficial { get; set; }
        public string Type { get; set; } = string.Empty;
        public string Path { get; set; } = string.Empty;
        public string FullPath { get; set; } = string.Empty;
        public string FileName { get; set; } = string.Empty;
        public DateTime? CreateTime { get; set; }
        public int Language { get; set; }

        public bool ReUpload { get; set; } = false;
    }

    public class ReviewerAckDTO
    {
        public Guid Id { get; set; }
        public Guid DoctorId { get; set; }
        public string Type { get; set; } = string.Empty;
        public string Path { get; set; } = string.Empty;
        public string FullPath =>  Path;
        public string FileName { get; set; } = string.Empty;
    }


    public class TrialSOWPathDTO
    {
        public Guid TrialId { get; set; }

        public string SowName { get; set; } = string.Empty;
        public string SowPath { get; set; } = string.Empty;
    }

    public class DeleteSowPathDTO
    {
        public Guid TrialId { get; set; }
        public string Path { get; set; } = string.Empty;

    }

    public class UploadAgreementAttachmentDTO
    {
        public Guid Id { get; set; }

        public Guid DoctorId { get; set; }
        public string Type { get; set; } = string.Empty;
        public string Path { get; set; } = string.Empty;
        public string FullPath =>  Path;

        public string FileName { get; set; } = string.Empty;
    }

    public class AttachementCommand
    {
        public Guid Id { get; set; }
        public string Path { get; set; } = string.Empty;
    }
}
