﻿using System;
using System.Collections.Generic;

namespace IRaCIS.Application.Contracts
{
    public class EducationCommand
    {
        public Guid? Id { get; set; }
        public Guid DoctorId { get; set; }
        public DateTime BeginDate { get; set; }
        public DateTime EndDate { get; set; }
        public string Degree { get; set; } = String.Empty;
        public string Major { get; set; } = String.Empty;
        public string Organization { get; set; } = String.Empty;
        public string Country { get; set; } = String.Empty;
        public string Province { get; set; } = String.Empty;
        public string City { get; set; } = String.Empty;

        public string DegreeCN { get; set; } = String.Empty;
        public string MajorCN { get; set; } = String.Empty;
        public string OrganizationCN { get; set; } = String.Empty;
        public string CountryCN { get; set; } = String.Empty;
        public string ProvinceCN { get; set; } = String.Empty;
        public string CityCN { get; set; } = String.Empty;

    }

    public class EducationInfoViewModel : EducationCommand
    {
        public DateTime? CreateTime { get; set; }
        public string BeginDateStr  => BeginDate.ToString("yyyy-MM");
        public string EndDateStr => EndDate.ToString("yyyy-MM");

    }
    public class PostgraduateCommand
    {
        public Guid? Id { get; set; }
        public Guid DoctorId { get; set; }
       
        public DateTime BeginDate { get; set; }
       
        public DateTime EndDate { get; set; }

        public string Training { get; set; } = String.Empty;

        public string Major { get; set; } = String.Empty;

        public string Hospital { get; set; } = String.Empty;

        public string School { get; set; } = String.Empty;

        public string Country { get; set; } = String.Empty;

        public string Province { get; set; } = String.Empty;

        public string City { get; set; } = String.Empty;

        public string TrainingCN { get; set; } = String.Empty;

        public string MajorCN { get; set; } = String.Empty;

        public string HospitalCN { get; set; } = String.Empty;

        public string SchoolCN { get; set; } = String.Empty;

        public string CountryCN { get; set; } = String.Empty;

        public string ProvinceCN { get; set; } = String.Empty;

        public string CityCN { get; set; } = String.Empty;

    }


    public class PostgraduateViewModel: PostgraduateCommand
    {
        public DateTime? CreateTime { get; set; }
        public string BeginDateStr => BeginDate.ToString("yyyy-MM");

        public string EndDateStr => EndDate.ToString("yyyy-MM");
    }
    public class DoctorEducationExperienceDTO
    {
      public  IEnumerable<EducationInfoViewModel> EducationList=new List<EducationInfoViewModel>();

      public IEnumerable<PostgraduateViewModel> PostgraduateList = new List<PostgraduateViewModel>();
    }

}