﻿using IRaCIS.Core.Infrastructure.Extention;

namespace IRaCIS.Application.Contracts
{
    public class WorkloadReadingDTO
    {
        public Guid Id { get; set; }

        public Guid StudyId { get; set; }
        public Guid TrialId { get; set; }
        public string TrialCode { get; set; } = string.Empty;
        public string TrialIndication { get; set; } = string.Empty;
        public string Sponsor { get; set; } = string.Empty;
        public int Expedited { get; set; }

        public Guid SubjectId { get; set; }
        public string SubjectCode { get; set; } = string.Empty;

        public string VisitName { get; set; } = string.Empty;
        public decimal VisitNum { get; set; }
       

        public Guid WorkloadId { get; set; }
        public string WorkloadCode { get; set; } = string.Empty;
        public int WorkloadType { get; set; }
        public int Status { get; set; }

        public DateTime UpdateTime { get; set; }
    }

    public class WorkloadQueryParam : PageInput
    {
        public Guid? TrialId { get; set; } = Guid.Empty;
        public string SubjectCode { get; set; } = string.Empty;
        public int? Status { get; set; }
        public int WorkloadType { get; set; }
        public int? Expedited { get; set; }
    }
}
