using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("DoctorWorkload")]
    public partial class Workload : Entity, IAuditUpdate, IAuditAdd
    {
        [Required]
        public Guid TrialId { get; set; }

        public Guid DoctorId { get; set; }

        public int DataFrom { get; set; }

        public DateTime WorkTime { get; set; }

        public int Training { get; set; }

        public int Downtime { get; set; }

        public int Timepoint { get; set; }

        public int TimepointIn24H { get; set; }

        public int TimepointIn48H { get; set; }

        public int Adjudication { get; set; }

        public int AdjudicationIn24H { get; set; }

        public int AdjudicationIn48H { get; set; }

        public int Global { get; set; }
        public int RefresherTraining { get; set; }

        public int CreateUserType { get; set; }

        [Required]
        public string YearMonth { get; set; }

        public bool IsLock { get; set; } = false;


        public Guid CreateUserId { get; set; }

        public DateTime CreateTime { get; set; }

        public Guid UpdateUserId { get; set; }

        public DateTime UpdateTime { get; set; }
    }
}
