

using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
	///<summary>
	/// 项目的临床数据
	///</summary>
	[Table("ReadingClinicalDataPDF")]
	public class ReadingClinicalDataPDF : Entity, IAuditAdd
	{
		/// <summary>
		/// 项目ID
		/// </summary>
		public Guid TrialId { get; set; }

		/// <summary>
		/// 对象ID
		/// </summary>
		public Guid ReadingId { get; set; }

		/// <summary>
		/// 受试者ID
		/// </summary>
		public Guid SubjectId { get; set; }

		/// <summary>
		/// 阅片临床数据ID
		/// </summary>
		public Guid ReadingClinicalDataId { get; set; }

		/// <summary>
		/// Path
		/// </summary>
		[Required]
		public string Path { get; set; }

		/// <summary>
		/// FileName
		/// </summary>
		[Required]
		public string FileName { get; set; }

		/// <summary>
		/// 是否为访视
		/// </summary>
		public bool IsVisit { get; set; }

		/// <summary>
		/// 临床级别
		/// </summary>
		public ClinicalLevel ClinicalDataLevel { get; set; }

		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public Guid CreateUserId { get; set; }


		/// <summary>
		/// 项目模板Id
		/// </summary>
		public Guid ClinicalDataTrialSetId { get; set; }




		[ForeignKey("ReadingClinicalDataId")]

		public ReadingClinicalData ReadingClinicalData { get; set; }
	}


	



}
