
using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace IRaCIS.Core.Domain.Models
{
	 ///<summary>
	 /// 阅片全局任务信息
	 ///</summary>
	 [Table("ReadingGlobalTaskInfo")]	
	 public class ReadingGlobalTaskInfo : Entity, IAuditAdd
	 {
	 
		/// <summary>
        /// 全局任务Id
        /// </summary>
		public Guid GlobalTaskId { get; set; }
	
		/// <summary>
        /// 原任务ID
        /// </summary>
		
		public Guid TaskId { get; set; }
	
		/// <summary>
        /// 问题ID
        /// </summary>
		public Guid? QuestionId { get; set; }
	
		/// <summary>
        /// 问题答案
        /// </summary>
		
		public string Answer { get; set; }
	
		/// <summary>
        /// CreateTime
        /// </summary>
		public DateTime CreateTime { get; set; }
	
		/// <summary>
        /// CreateUserId
        /// </summary>
		public Guid CreateUserId { get; set; }
	
		/// <summary>
        /// TrialId
        /// </summary>
	
		public Guid TrialId { get; set; }
	
		/// <summary>
        /// SubjectId
        /// </summary>
		public Guid SubjectId { get; set; }
	 
	 }

	 
}	 
