

using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace IRaCIS.Core.Domain.Models
{
	 ///<summary>
	 ///阅片裁判信息
	 ///</summary>
	 [Table("ReadingJudgeInfo")]	
	 public class ReadingJudgeInfo : Entity, IAuditAdd
	{
		/// <summary>
        /// 第一个任务ID
        /// </summary>
		[Required]
		public Guid TaskIdOne { get; set; }
	
		/// <summary>
        /// 第二个任务ID
        /// </summary>
		[Required]
		public Guid TaskIdTwo { get; set; }
	
		/// <summary>
        /// 裁判任务ID
        /// </summary>
		[Required]
		public Guid JudgeTaskId { get; set; }
	
		/// <summary>
        /// 创建时间
        /// </summary>
		[Required]
		public DateTime CreateTime { get; set; }
	
		/// <summary>
        /// 创建人
        /// </summary>
		[Required]
		public Guid CreateUserId { get; set; }
	
		/// <summary>
        /// 项目ID
        /// </summary>
		[Required]
		public Guid TrialId { get; set; }

		/// <summary>
		/// 受试者ID
		/// </summary>
		[Required]
		public Guid SubjectId { get; set; }

	}

	
}	 
