﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Text;

namespace IRaCIS.Core.Domain.Models
{
    [Table("Report")]
    public class Report : Entity
    {
        public bool Qualified { get; set; } = true;
        public string DiseaseProgression { get; set; } = string.Empty;
        public string NotEvaluable { get; set; } = string.Empty;
        public string Timepoint { get; set; } = string.Empty;
        public string TrialCode { get; set; } = string.Empty;
        public string SubjectCode { get; set; } = string.Empty;
        public decimal? VisitNum { get; set; }
        public string VisitName { get; set; } = string.Empty;
        public int? DiseaseSituation { get; set; }
        public string Comment { get; set; }
        public Guid? TPId { get; set; }
        public Guid? DicomStudyId { get; set; }
        public string TpCode { get; set; } = string.Empty;
        public bool AffectRead { get; set; } = false;//是否影响读片
        public string AffectReadNote { get; set; } = string.Empty;//备注说明
    }
}
