using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("EnrollDetail")]
    public partial class EnrollDetail : Entity, IAuditAdd
    {
        public virtual TrialStatusDetail  TrialDetail { get; set; }

        public Guid DoctorId { get; set; }
        public Guid TrialId { get; set; }
        public int EnrollStatus { get; set; }
        public Guid? EnrollId { get; set; }
        public string Memo { get; set; } = string.Empty;
        public Guid CreateUserId { get; set; }
        public int OptUserType { get; set; }
        public DateTime CreateTime { get; set; }

        [ForeignKey("TrialDetail")]
        public Guid TrialDetailId { get; set; }

        
        [ForeignKey("CreateUserId")]
        public User CreateUser { get; set; }  
        public Doctor Doctor { get; set; }  
    }
}
